/**
 * @author Стаценко Владимир http://www.simplecoding.org
 */
//глобальный объект для работы с настройками формы
var builder = new FieldsListBuilder;
//id последнего вставленного поля
var lastId = 1;

//эта функция выполняется сразу после загрузки страницы
$(document).ready(function() {
	//скрываем горизонтальный загрузчик
	$("#generationProcess").addClass("hide");
	$("#content").tabs();
	//создаем первую строку в таблице
	builder.addField(false);
	//обработчик кнопки "Новое поле"
	$("#addField").click(function() {
		builder.addField(true);
	});
	//обработчик кнопки "Генерировать код"
	$("#generateCode").click(function() {
		var generator = new CICodeGenerator;
		generator.generate();
		//прячем кнопку и показываем горизонтальный загрузчик
		$("#generateCode").addClass("hide");
		$("#generationProcess").removeClass("hide");
		//добавляем на каждый таб (кроме "Настроек") анимацию
		var tabs = $("ul > li:not(.ui-tabs-selected)");
		tabs.each(function() {
			$(this).children("img")[0].src = "images/circle_loader.gif";
		});
		//запускаем таймер
		setTimeout(function() {
			var tabs = $("ul > li:not(.ui-tabs-selected)");
			tabs.each(function() {
				$(this).children("img")[0].src = "images/light_blank.png";
			});
			//скрываем горизонтальный загрузчик и показываем кнопку
			$("#generationProcess").addClass("hide");
			$("#generateCode").removeClass("hide");
		},
		1000);
		//после завершения работы таймера убираем анимацию
	});
	$("#options_link").tooltip({
		bodyHandler: function(){
			return $("#options_tip")[0].innerHTML;
		},
		showURL: false
	});
	$("#servercode_link").tooltip({
		bodyHandler: function(){
			return $("#servercode_tip")[0].innerHTML;
		},
		showURL: false
	});
	$("#clientcode_link").tooltip({
		bodyHandler: function(){
			return $("#clientcode_tip")[0].innerHTML;
		},
		showURL: false
	});
	$("#styles_link").tooltip({
		bodyHandler: function(){
			return $("#styles_tip")[0].innerHTML;
		},
		showURL: false
	});
	$("ul > li > a").click(function(event) {
		$("ul > li > img").each(function() {
			$(this)[0].src = "images/light_blank.png";
		});
		var curImg = $(this).parent().children("img");
		curImg[0].src = "images/dark_blank.png";
	});
});

//удаление поля из формы
function removeField(fieldId) {
	builder.removeField(fieldId);
}

//этот класс выполняет анализ введенных данных и
//создает форму с помощью FormGenerator
function CICodeGenerator() {
	this.t = new FormGenerator;
}

CICodeGenerator.prototype.generate = function() {
	//чтение исходных данных
	var fieldsData = builder.getFields();
	//создание серверной части кода
	var st = $("#servercode > p > textarea")[0];
	var faction = $("#formaction");
	//создание клиентской части кода
	var ct = $("#clientcode > p > textarea")[0];
	var faction = $("#formaction");
	var fopen = this.t.formopen(faction[0].value)
	ct.value = fopen["client"];
	st.value = fopen["server"];
	for (var i = 0; i < fieldsData.length; i++) {
		var curField = this.t["get" + fieldsData[i]["type"]](fieldsData[i]);
		ct.value += curField["client"];
		st.value += curField["server"];
	}
	var fclose = this.t.formclose();
	ct.value += fclose["client"];
	st.value += fclose["server"];
	//создание JavaScript кода (AJAX)
	//создание таблицы стилей (CSS)
	$("#styles > p > textarea")[0].value = this.t.getCSS();
}

//класс для работы со страницей настроек
//(добавление и удаление полей формы)
function FieldsListBuilder() {
	this.types = new Array("button", "checkbox", "hidden", "image", "password", 
		"radio", "reset", "select", "submit", "text", "textarea");
}

FieldsListBuilder.prototype.addField = function(hasRemove) {
	var field = "<tr><td><select class=\"ftype\" size=\"1\">";
	for (var i = 0; i < this.types.length; i++) {
		field += "<option>" + this.types[i] + "</option>";
	}
	field += "</select></td>";
	field += "<td><input type=\"text\" class=\"fid\" /></td>";
	field += "<td><input type=\"text\" class=\"fvalue\" /></td>";
	field += "<td><input type=\"text\" class=\"frules\" /></td>";
	if (hasRemove) {
		var fieldId = ++lastId;
		field += "<td><a href=\"#\" id=\"removeField_" + fieldId +
			"\" onclick=\"removeField('" + fieldId + "')\">Удалить</a></td>";
	}
	else {
		field += "<td>&nbsp;</td>";
	}
	field += "</tr>";
	$("#options > form > table > tbody").append(field);
	$(".removeField").click(function(event) {
		builder.removeField(this);
	});
}

FieldsListBuilder.prototype.removeField = function(fieldId) {
	$("#removeField_" + fieldId).parent().parent().remove();
}

FieldsListBuilder.prototype.getFields = function() {
	//TODO вернуть массив со всеми введенными данными
	//[0].fieldType
	//[0].fieldId и т.д.
	var fieldsTypes = $(".ftype");
	var fieldsIds = $(".fid");
	var fieldsRules = $(".frules");
	var fieldsValues = $(".fvalue");
	var resArray = new Array();
	for (var i = 0; i < fieldsTypes.length; i++) {
		resArray[i] = new Array();
		resArray[i]["type"] = fieldsTypes[i].value;
		resArray[i]["id"] = fieldsIds[i].value;
		resArray[i]["rules"] = fieldsRules[i].value;
		resArray[i]["value"] = fieldsValues[i].value;
	}
	return resArray;
}

//класс для создания кода отдельных полей формы
function FormGenerator() {
}

FormGenerator.prototype.getCSS = function() {
	return "form p {\n" +
	  "\tclear: left;\n" +
	"}\n" +
	"form p label {\n" +
	  "\tfloat: left;\n" +
	  "\twidth: 30%;\n" +
	"}";
}

FormGenerator.prototype.formopen = function(action) {
	var res = new Array();
	res["client"] = "<?php echo form_open('" + action + "'); ?>\n";
	res["server"] = "$this->load->helper('form');\n$this->load->library('validation');\n";
	return res;
}

FormGenerator.prototype.formclose = function() {
	var res = new Array();
	res["client"] = "</form>";
	res["server"] = "$this->validation->set_rules($rules);\n" +
					"$this->validation->set_fields($fields);\n" +
					"if ($this->validation->run() === FALSE) {\n" +
					"\t//ошибка\n" +
					"}\nelse {\n" +
					"\t//форма заполнена правильно\n" +
					"}";
	return res;
}

FormGenerator.prototype.gettext = function(fieldData) {
	var res = new Array();
	res["client"] =
		"\t<p>\n\t<?php if (isset($this->validation->" + fieldData["id"] + "_error)) {\n\techo $this->validation->" + fieldData["id"] + "_error;\n\t} ?>\n" +
		"\t<label for=\"" + fieldData["id"] + "\">" + fieldData["value"] + "</label>\n" +
		"\t<input type=\"text\" name=\"" + fieldData["id"] + "\" id=\"" + fieldData["id"] +
		"\" value=\"<?php if (isset($this->validation->" + fieldData["id"] + ")) {echo $this->validation->" +
		fieldData["id"] + ";} ?>\" />\n\t</p>\n";
	res["server"] =
		"$fields['" + fieldData["id"] + "'] = '" + fieldData["id"] + "';\n" +
		"$rules['" + fieldData["id"] + "'] = '" + fieldData["rules"] + "';\n";
	return res;
}

FormGenerator.prototype.getpassword = function(fieldData) {
	var res = new Array();
	res["client"] = "\t<p>\n\t<?php if (isset($this->validation->" + fieldData["id"] + "_error)) {\n\techo $this->validation->" + fieldData["id"] + "_error;\n\t} ?>\n" +
		"\t<label for=\"" + fieldData["id"] + "\">" + fieldData["value"] + "</label>\n" +
		"\t<input type=\"password\" name=\"" + fieldData["id"] + "\" id=\"" +
		fieldData["id"] + "\" />\n\t</p>\n";
	res["server"] =
		"$fields['" + fieldData["id"] + "'] = '" + fieldData["id"] + "';\n" +
		"$rules['" + fieldData["id"] + "'] = '" + fieldData["rules"] + "';\n";
	return res;
}

FormGenerator.prototype.gethidden = function(fieldData) {
	var res = new Array();
	res["client"] =
		"\t<p><input type=\"hidden\" name=\"" + fieldData["id"] + "\" id=\"" + fieldData["id"] + "\" /></p>\n";
	res["server"] = "";
	return res;
}

FormGenerator.prototype.getsubmit = function(fieldData) {
	var res = new Array();
	res["client"] = "\t<p>" +
		"<input type=\"submit\" name=\"" + fieldData["id"] + "\" id=\"" +
		fieldData["id"] + "\" value=\"" + fieldData["value"] + "\" />\n\t</p>\n";
	res["server"] = "";
	return res;
}

FormGenerator.prototype.getreset = function(fieldData) {
	var res = new Array();
	res["client"] = "\t<p>" +
		"<input type=\"reset\" name=\"" + fieldData["id"] + "\" id=\"" +
		fieldData["id"] + "\" value=\"" + fieldData["value"] + "\" />\n\t</p>\n";
	res["server"] = "";
	return res;
}

FormGenerator.prototype.getcheckbox = function(fieldData) {
	var res = new Array();
	res["client"] = "\t<p>\n" +
		"\t<label for=\"" + fieldData["id"] + "\">" + fieldData["value"] + "</label>\n" +
		"\t<input type=\"checkbox\" name=\"" + fieldData["id"] + "\" id=\"" + fieldData["id"] +
		"\" value=\"" + fieldData["value"] + "\" <?php echo $this->validation->set_checkbox('" +
		fieldData["id"] + "', '" + fieldData["value"] + "'); ?> />\n\t</p>\n";
	res["server"] = "";
	return res;
}

FormGenerator.prototype.getradio = function(fieldData) {
	var res = new Array();
	res["client"] = "\t<p>\n" +
		"\t<label for=\"" + fieldData["id"] + "\">" + fieldData["value"] + "</label>\n" +
		"\t<input type=\"radio\" name=\"" + fieldData["id"] + "\" id=\"" + fieldData["id"] +
		"\" value=\"" + fieldData["value"] + "\" <?php echo $this->validation->set_radio('" +
		fieldData["id"] + "', '" + fieldData["value"] + "'); ?> />\n\t</p>\n";
	res["server"] = "";
	return res;
}

FormGenerator.prototype.getimage = function(fieldData) {
	var res = new Array();
	res["client"] = "\t<p>" +
		"<input type=\"image\" name=\"" + fieldData["id"] + "\" id=\"" + fieldData["id"] +
		"\" src=\"" + fieldData["value"] + "\" />\n\t</p>\n";
	res["server"] = "";
	return res;
}

FormGenerator.prototype.getbutton = function(fieldData) {
	var res = new Array();
	res["client"] = "\t<p>" +
		"<input type=\"button\" name=\"" + fieldData["id"] + "\" id=\"" + fieldData["id"] +
		"\" value=\"" + fieldData["value"] + "\" />\n\t</p>\n";
	res["server"] = "";
	return res;
}

FormGenerator.prototype.gettextarea = function(fieldData) {
	var res = new Array();
	res["client"] = "\t<p>\n\t<?php if (isset($this->validation->" + fieldData["id"] + "_error)) {\n\techo $this->validation->" + fieldData["id"] + "_error;\n\t} ?>\n" +
		"\t<label for=\"" + fieldData["id"] + "\">" + fieldData["value"] + "</label>\n" +
		"\t<textarea name=\"" + fieldData["id"] + "\" id=\"" + fieldData["id"] +
		"\" cols=\"30\" rows=\"5\"><?php if (isset($this->validation->" + fieldData["id"] +
		")) {echo $this->validation->" + fieldData["id"] + ";} ?></textarea>\n\t</p>\n";
	res["server"] =
		"$fields['" + fieldData["id"] + "'] = '" + fieldData["id"] + "';\n" +
		"$rules['" + fieldData["id"] + "'] = '" + fieldData["rules"] + "';\n";
	return res;
}

FormGenerator.prototype.getselect = function(fieldData) {
	var res = new Array();
	res["client"] = "\t<p>\n\t<?php if (isset($this->validation->" + fieldData["id"] + "_error)) {\n\techo $this->validation->" + fieldData["id"] + "_error;\n\t} ?>\n" +
		"\t<label for=\"" + fieldData["id"] + "\">" + fieldData["value"] + "</label>\n" +
		"\t<select name=\"" + fieldData["id"] + "\" id=\"" + fieldData["id"] + "\" size=\"1\">\n" +
		"\t<!-- цикл для добавления опций <option value=\"...\">...</option> -->\n" +
		"\t<!-- для восстановления предыдущего значения нужно использовать -->\n" +
		"\t<!-- <?php echo $this->validation->set_select('" + fieldData["id"] + "', 'значение'); ?> -->\n" +
		"\t</select>\n" +
		"\t</p>\n";
	res["server"] =
		"$fields['" + fieldData["id"] + "'] = '" + fieldData["id"] + "';\n" +
		"$rules['" + fieldData["id"] + "'] = '" + fieldData["rules"] + "';\n";
	return res;
}